<!--
  @description: 报表统计-专家统计-专家出席率-更多弹框
  @Modifier: 郝定康
  @routerPath:
  @date: 2021-03-15 13:27:40
-->
<template>
  <el-dialog
    v-dialogDrag
    :modal="false"
    :visible.sync="dialog"
    :close-on-click-modal="false"
    title="更多信息"
    width="840px"
  >
    <el-form ref="searchForm" :model="searchForm" inline>
      <el-form-item label="专家姓名">
        <el-input v-model="searchForm.expertName" />
      </el-form-item>
      <el-form-item class="fr">
        <el-button type="primary" round @click="search">
          查询
        </el-button>
        <el-button type="primary" round @click="resetForm('searchForm')">
          重置
        </el-button>
        <el-button type="primary" round @click="exportChange()">
          导出
        </el-button>
      </el-form-item>
    </el-form>
    <tableChart
      :height="height"
      class="echart-dom"
      :option="option"
    />
    <pagination :pagination-data="paginationData" @change="loadData" />
    <!-- 报表统计-专家统计-专家出席率详情 -->
    <expertBePresentRateDetail ref="tenderDetail" />
  </el-dialog>
</template>

<script>
/* api */
import { listExpertAttendanceRate, exportExpertAttendanceRate } from '@api/statisticalAnalysis/reportChart.js'
/* 公用方法*/
import { filterObj, restoreInitialValue, download } from '@/assets/js/utils'// 过滤空的key
/* 混合开发方法-参数字段*/
import { ListMixin } from '@/mixins/ListMixin'// 分页
/* 組件 */
import tableChart from './../../components/tableChart'// table列表渲染组件
import pagination from '@comp/common/pagination/pagination'// 分页
import expertBePresentRateDetail from './expertBePresentRateDetail-dialog.vue' // 报表统计-专家统计-专家评标项目详情

export default {
  name: 'ExpertBePresentRateMoreListDialog',
  components: {
    tableChart, // table列表渲染组件
    pagination, // 分页
    expertBePresentRateDetail // 报表统计-专家统计-专家评标项目详情
  },
  mixins: [ListMixin],
  data() {
    return {
      height: '450px', // 高度
      dialog: false, // 弹窗状态
      // 查询条件
      searchForm: {
        expertName: '' // 专家姓名
      },
      // 全局搜索
      searchChartData: {

      },
      option: {
        // 非TOP排序
        showIndexTOP: false,
        // 标题
        thead: [
          { lable: '专家姓名', prop: 'expertName', align: 'left' },
          { lable: '出席率', prop: 'attendanceRate', align: 'center' },
          { lable: '评标项目', width: 120,
            // 操作类
            handle: [
              {
                text: '查看',
                click: this.detail
              }
            ] }
        ],
        // 渲染数据
        data: []
      }
    }
  },
  methods: { /**
     * 打开弹窗
     *  @param {row} Object 供应商信息
     *  @param {searchChartData} Object 全局的查询条件
    */
    open(searchChartData) {
      this.dialog = true
      this.searchChartData = searchChartData
      this.paginationData.pageNo = 1
      this.loadData()
    },
    // 获取数据
    loadData() {
      this.option.data = []
      const data = this.getParams()
      listExpertAttendanceRate(data).then(res => {
        this.paginationData.total = res.data.total
        this.option.data.push(...res.data.records)
        // this.option.data.push(...res.data)
      })
    },
    // 查询条件
    getParams() {
      const param = {
        ...this.searchForm,
        ...this.searchChartData
      }
      param.pageNo = this.paginationData.pageNo
      param.pageSize = this.paginationData.pageSize
      return filterObj(param)// 过滤空的key
    },
    // 搜索
    search() {
      this.paginationData.pageNo = 1
      this.paginationData.pageSize = 10
      this.loadData()
    },
    // 重置
    resetForm(formName) {
      restoreInitialValue(this.searchForm)
      this.search()
    },
    // 导出
    exportChange() {
      const data = this.getParams()
      exportExpertAttendanceRate(data).then(res => {
        download(res, '专家出席率信息表.xls')
      })
    },
    // 查看
    detail(row) {
      this.$refs.tenderDetail.open(row.row)
    }
  }
}
</script>

<style scoped lang="less">
</style>
